/** 

@file rtifunctions.i Load auto generated function bindings
 
**/


/*
**************************************************
**************************************************
**************************************************

Function interface preface

**************************************************
**************************************************
**************************************************
*/

// Set SWIG module name
%module functions

// Load std SWIG includes
%include <std_string.i>
%include <std_except.i>

// Import core faudes interface
%import "corefaudes.i"


// Extra c code in wrapper file
%{

// include relevant faudes headers
#include "corefaudes.h"
#include "allplugins.h"

// use libfaudes namespace
using namespace faudes;

// access mini help system
extern void luafaudes_dict_insert_topic(const std::string& topic, const std::string& entry);
extern void luafaudes_dict_insert_entry(const std::string& topic, const std::string& key, const std::string& entry);

%}

// Extra Lua functions: copy to faudes name space
%luacode {
-- Copy functions to faudes name space
for k,v in pairs(functions) do faudes[k]=v end
}


// Extra Lua functions: debugging
#ifdef FAUDES_DEBUG_LUABINDINGS
%luacode {
-- Say hello
print("libFAUDES: rti auto functions")
}
#endif


// Import other plugin interfaces
%import "op_interface.i"
%import "hio_interface.i"
%import "pex_interface.i"

// include rti auto file
%include "../../../include/rtiautoload.i"
